searchNodes=[{"doc":"t-distributed stochastic neighbor embedding (t-SNE) is a statistical method for visualizing high-dimensional data in two or three dimensions. This library provides bindings to fast exact and Barnes-Hut implementations of t-SNE in Rust using the bhtsne crate.","ref":"Tsne.html","title":"Tsne","type":"module"},{"doc":"Barnes Hut t-SNE. Barnes-Hut is a tree-based algorithm for accelerating t-SNE. It runs in O(NlogN) time (while exact runs in O(N^2)) time. Options :embedding_dimensions ( integer/0 ) - Dimension of the embedded space. The default value is 2 . :learning_rate ( float/0 ) - The learning rate for t-SNE is usually in the range [10.0, 1000.0]. If the learning rate is too high, the data may look like a ‘ball’ with any point approximately equidistant from its nearest neighbours. If the learning rate is too low, most points may look compressed in a dense cloud with few outliers. If the cost function gets stuck in a bad local minimum increasing the learning rate may help. The default value is 200.0 . :epochs ( integer/0 ) - Maximum number of iterations for the optimization. Should be at least 250. The default value is 1000 . :perplexity ( float/0 ) - The perplexity is related to the number of nearest neighbors that is used in other manifold learning algorithms. Larger datasets usually require a larger perplexity. Consider selecting a value between 5 and 50. Different values can result in significantly different results. The perplexity must be less than the number of samples. The default value is 30.0 . :final_momentum ( float/0 ) - The value for momentum after the initial early exaggeration phase. See momentum for more info. The default value is 0.8 . :momentum ( float/0 ) - Gradient descent with momentum keeps a sum exponentially decaying weights from previous iterations, speeding up convergence. In early stages of the optimization, this is typically set to a lower value (0.5 in most implementations) since points generally move around quite a bit in this phase and increased after the initial early exaggeration phase (typically to 0.8, see: final_momentum ) to speed up convergence. The default value is 0.5 . :metric - The distance metric to use. Must be either :euclidean or :cosine . The default value is :euclidean . :theta ( float/0 ) - The tradeoff parameter between accuracy (0) and speed (1). The default value is 0.5 .","ref":"Tsne.html#barnes_hut/2","title":"Tsne.barnes_hut/2","type":"function"},{"doc":"Exact t-SNE. Options :embedding_dimensions ( integer/0 ) - Dimension of the embedded space. The default value is 2 . :learning_rate ( float/0 ) - The learning rate for t-SNE is usually in the range [10.0, 1000.0]. If the learning rate is too high, the data may look like a ‘ball’ with any point approximately equidistant from its nearest neighbours. If the learning rate is too low, most points may look compressed in a dense cloud with few outliers. If the cost function gets stuck in a bad local minimum increasing the learning rate may help. The default value is 200.0 . :epochs ( integer/0 ) - Maximum number of iterations for the optimization. Should be at least 250. The default value is 1000 . :perplexity ( float/0 ) - The perplexity is related to the number of nearest neighbors that is used in other manifold learning algorithms. Larger datasets usually require a larger perplexity. Consider selecting a value between 5 and 50. Different values can result in significantly different results. The perplexity must be less than the number of samples. The default value is 30.0 . :final_momentum ( float/0 ) - The value for momentum after the initial early exaggeration phase. See momentum for more info. The default value is 0.8 . :momentum ( float/0 ) - Gradient descent with momentum keeps a sum exponentially decaying weights from previous iterations, speeding up convergence. In early stages of the optimization, this is typically set to a lower value (0.5 in most implementations) since points generally move around quite a bit in this phase and increased after the initial early exaggeration phase (typically to 0.8, see: final_momentum ) to speed up convergence. The default value is 0.5 . :metric - The distance metric to use. Must be either :euclidean or :cosine . The default value is :euclidean . :theta ( float/0 ) - The tradeoff parameter between accuracy (0) and speed (1). The default value is 0.5 .","ref":"Tsne.html#exact/2","title":"Tsne.exact/2","type":"function"},{"doc":"","ref":"Tsne.Native.html","title":"Tsne.Native","type":"module"},{"doc":"","ref":"Tsne.Native.html#barnes_hut/10","title":"Tsne.Native.barnes_hut/10","type":"function"},{"doc":"","ref":"Tsne.Native.html#exact/9","title":"Tsne.Native.exact/9","type":"function"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright [yyyy] [name of copyright owner] Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"},{"doc":"Mix . install ( [ { :exla , &quot;~&gt; 0.5&quot; } , { :kino_vega_lite , &quot;~&gt; 0.1&quot; } , { :nx , &quot;~&gt; 0.5&quot; } , { :rustler , &quot;~&gt; 0.0&quot; } , { :scholar , &quot;~&gt; 0.1&quot; } , { :tsne , &quot;~&gt; 0.1&quot; } , { :vega_lite , &quot;~&gt; 0.1.7&quot; } ] , config : [ nx : [ default_backend : EXLA.Backend ] ] )","ref":"dimensionality_reduction.html","title":"Dimensionality Reduction with t-SNE","type":"extras"},{"doc":"alias VegaLite , as : Vl Generate some random data. key = Nx.Random . key ( 42 ) { data , _ } = Nx.Random . normal ( key , 0 , 1 , shape : { 1000 , 256 } , type : :f32 ) Then, because t-SNE does better if it doesn't need to reduce massive vectors, we use Scholar to extract the principal components. This brings our dimensions down to 50, which t-SNE can handle more readily. principal_components = Scholar.Decomposition.PCA . fit_transform ( data , num_components : 50 ) Okay, now we can get the embeddings. We convert to a list of lists, which is what Tsne expects, then call Tsne.barnes_hut/1 . You can also pass in options in Tsne.barnes_hut/2 . embeddings = principal_components |&gt; Nx . to_list ( ) |&gt; Tsne . barnes_hut ( ) |&gt; Enum . map ( fn [ x , y ] -&gt; %{ x : x , y : y } end ) And we can visualise the results with VegaLite . Might be more interesting with real, labeled data. Vl . new ( ) |&gt; Vl . data_from_values ( embeddings ) |&gt; Vl . mark ( :point ) |&gt; Vl . encode_field ( :x , &quot;x&quot; , type : :quantitative ) |&gt; Vl . encode_field ( :y , &quot;y&quot; , type : :quantitative )","ref":"dimensionality_reduction.html#section","title":"Dimensionality Reduction with t-SNE - Section","type":"extras"}]